/* UpTools v8.6
 *
 * Copyright (c) 2005-2012 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <UpTools/UpConf.h>

int main(int argc, char *argv[]) {
	if(argc!=2) {
		std::cerr << "Usage: " << argv[0] << " config-file" << std::endl;
		return 1;
	}
	UpConf conf;
	conf.addParam("manual_param1","this is a manually added param value 1");
	conf.parseFile(argv[1]);
	conf.addParam("manual_param2","this is a manually added param value 2");

	if( !conf.getStatus() ) {
		std::cerr << conf.getStatusPhrase() << std::endl;
		return 1;
	}
	/*
	std::cout << "Total parameters read: " << conf.keyCount() << std::endl;
	std::string key;

	for(;;) {
		key = conf.getKey();
		if( !key.size() ) break;
		std::cout << "Param: " << key << " (" << conf.paramCount(key)
					 << " values)" << std::endl;
		for(;;) {
			const std::string& val=conf.getParam(key);
			if(!val.size()) break;
			std::cout << " value: " << val << std::endl;
		}
	}
	*/
	std::cout<<conf<<std::endl;

	return 0;
}
