/* UpTools v8.6
 *
 * Copyright (c) 2005-2012 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <UpTools/UpSqlPgsql.h>
#include <iostream>

using namespace std;

int main(int argc, char *argv[]) {
	if(argc<3) {
		cerr	<<"usage: "<<argv[0]
				<<" postgresql://user:pass@serveraddress:port/dbname sqlQuery\n"
				<<"example: "<<argv[0]<<" 'SELECT * FROM mytable' [count]" <<endl;
		return 1;
	}
	int count = ( argc>3 ) ? atoi(argv[3]) : 1 ;
for(int x=0;x<count; x++) {
	UpSqlConnPgsql db;
	if( !	db.connect(argv[1]) ) {
		cerr<<db.errorPhrase()<<endl;
		return 2;
	}
	UpSqlQuery q;
	q.sql << argv[2];
	if( ! db.exec(q) ) {
		cerr<<db.errorPhrase()<<endl;
		return 2;
	}
	do {
		unsigned int fCount = q.fieldCount();
		while(q.fetchRow()) {
			cout<<q.col(0);
			for(unsigned int i=1; i<fCount; ++i )
				cout<<";"<<q.col(i);
			cout<<"\n";
		}
	} while( q.nextResult() );
}
	return 0;
}

