/* UpTools v8.6
 *
 * Copyright (c) 2005-2012 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <UpTools/UpTimeVal.h>
#include <iostream>
using namespace std;
int main(int argc, char* argv[]) {
	int count= (argc>1) ? atoi(argv[1]) : 1000000;

	cout << "Iterating "<<count<<" times to compare multiplication delays\n"
			"    for different types and UpTimeVal"<<endl;
	UpTimeVal a(5.654321),b,t;
	t.tic();
	for(int i=0; i<count; ++i ) {
		b=a;
		b*=(unsigned int)10000;
	}
	t.toc();
	cout <<"UpTimeVal multipled by unsigned int loop time:"<<t<<endl;
	t.tic();
	for(int i=0; i<count; ++i ) {
		b=a;
		b*=(double)10000.0;
	}
	t.toc();
	cout <<"UpTimeVal multipled by double loop time:"<<t<<endl;
	t.tic();

	cout << "\n\n\nIterating "<<count<<" times to compare division delays\n"
			"    for different types and UpTimeVal"<<endl;
	double d;
	a=867565435.28923; b=10000.24352;
	t.tic();
	for(int i=0; i<count; ++i ) {
		d=a/b;
	}
	t.toc();
	cout <<"UpTimeVal divided by UpTimeVal loop time:"<<t<<endl;
	t.tic();
	for(int i=0; i<count; ++i ) {
		d=a/((double)10000.24352);
	}
	t.toc();
	cout <<"UpTimeVal divided by double loop time:"<<t<<endl;
	t.tic();
	for(int i=0; i<count; ++i ) {
		d=a/(time_t)10000;
	}
	t.toc();
	cout <<"UpTimeVal divided by time_t loop time:"<<t<<endl;

	t.now();
	string s;
	t.charDateTime(s);
	cout<<"\n\ncurrent date and time: "<<s<<"\nt="<<t<<endl;


	//t.readDateTime(s);
	//t.charDateTime(s);
	//cout<<"reading date from string...\nre-readdate and time="<<s<<"\nt="<<t<<endl;

	//s="27-Aug-2009";
	//t.readDate(s);
	//cout<<"\n\nreading date from string:"<<s<<"\nt="<<t<<endl;
	//t.charDate(s);
	//t.readDate(s);
	//cout<<"writing date to string...\nre-written string="<<s<<"\nt="<<t<<endl;

	//t=(time_t)3675;
	//t.charTime(s);
	//cout<<"\n\nt="<<t<<"\ns="<<s<<endl;

	return 0;
}
